/****************************************************************************
** COPYRIGHT (C):    1997 Cay S. Horstmann. All Rights Reserved.
** PROJECT:          Practical OO Development with C++ and Java
** FILE:             datetest.cpp
** PURPOSE:          test date.cpp
** VERSION           1.0
** PROGRAMMERS:      Cay Horstmann (CSH)
** RELEASE DATE:     3-15-97 (CSH)
** UPDATE HISTORY:
****************************************************************************/

/* Project:
   Console Application
   Add files
      datetest.cpp
      date.cpp
   Additional include directory:
      \PracticalOOBook\cpplib
*/

#include <stdlib.h>
#include "setup.h"
#include "date.h"

int main(int argc, char* argv[])
{  int m;
   int y;
   if (argc == 3)
   {  m = atoi(argv[1]);
      y = atoi(argv[2]);
   }
   else
   {  cout << "Usage: " << argv[0] << " month year" << endl;
      cout << "Using January 1900." << endl;
      m = 1;
      y = 1900;
   }

   Date d(1, m, y); // start date of the month

   cout << "Mon Tue Wed Thu Fri Sat Sun" << endl;
   Date::Weekday w = d.weekday();
   for( int i = 0; i < w; i++ ) cout << "    ";
   while (d.month() == m)
   {  cout.width(3);
      cout << d.day();
      if (w == Date::SUN) { cout << endl; w = Date::MON;}
      else { cout << " "; w = (Date::Weekday)(w + 1); }
      d.advance(1);
   }
   if (w != Date::MON) cout << endl;
   return 0;
}


